Subject: RE: t5570 - not cloned error

From: "Randall S. Becker" <[email-masked]>
Date: Tue, 5 May 2015 20:46:09 -0400

On May 5, 2015 6:55 PM Jeff King wrote:
> On Tue, May 05, 2015 at 06:23:41PM -0400, Randall S. Becker wrote:
> > On May 5, 2015 6:01 PM Junio C Hamano wrote:
> > > "Randall S. Becker" <[email-masked]> writes:
> > > > We definitely have an issue with localhost. When forcing the DNS
> > resolver to
> > > > return 127.0.0.1, we pass 1-16 then 17 fails as I expected to happen
> > based
> > > > on my DNS futzing. Heads up that this test is not-surprisingly sensitive
> > to
> > > > DNS problems. My environment is still in a messy state where I can
> > reproduce
> > > > the original problem so it might be a useful moment for me to find a way
> > to
> > > > modify the test script to harden it. Any suggestion on that score
> > > > (as in where and roughly how it might be made more reliable)?
> > >
> > > I do not think this counts as a useful "suggestion", but is this
> > > "resolver does not work for local as expected" case even worth
> > > protecting our tests against?
> >
> > I see your point, but after having spent "way too much time" away from the
> > $DAYJOB tracking this down, I was hoping to catch the root cause earlier
> > next time. Perhaps adding a test step validating that localhost comes back
> > with a reasonable value - whatever that may be in context. I'm just not sure
> > what the test really needs at its heart to run properly - obviously the IP
> > address of the system as  visible in our DMZ is not working for the test.
> 
> I'm having trouble even understanding who is looking up "localhost"
> here.  All of the git-daemon tests should be directly using 127.0.0.1 in
> the URLs (i.e., what is in $GIT_DAEMON_URL). If that is a problem, I
> think you might be able to parameterize the way we set up
> $GIT_DAEMON_URL (and how we invoked git-daemon; see lib-git-daemon.sh).
> 
> In the interpolation tests, we do use the string "localhost" but we
> should never do a lookup on it. We set an environment variable that
> tells the git client to _tell_ the server we looked up localhost, but we
> should still be accessing it as 127.0.0.1.
> 
> So I'm confused about what the actual problem is, or why the test cares
> about resolving "localhost" in the first place.

That gives me a pretty good idea of where to start looking. I will first hunt down the resolution and go from there. Stay tuned - it may be a day or two before I have a chance to do more than a cursory debug.

Cheers,
Randall